<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Scaffolding</h1>

		<p>CarbonPHP has a scaffolding feature that provides an easy and fast way to add, edit, or delete data
		from your database during the development of your application.</p>

		<p>You should also take note that scaffolding is only intended for use while you are developing your
		application.  It provides zero security except for a <b>secret word</b>.  Anyone who has access to this
		secret word has access to your database.  You should disabled scaffolding when you make your application live
		and make sure you set a secret word when you do use it.</p>
	</div>

	<div class="content">
		<h1>Uses For Scaffolding</h1>

		<p>A typical scenario is that you are creating a new database during development and you would like to
		have a quick way to insert data into the database to test with.  Without the use of scaffolding you
		would either have to manually insert data via the command line or a tool like phpMyAdmin.  Using
		CarbonPHP's scaffolding feature you can quickly insert some data using the web interface.</p>
	</div>

	<div class="content">
		<h1>Setting a Scaffolding Secret Word</h1>

		<p>Before you enable scaffolding you should take the time to set a secret word.  This word will launch
		scaffolding when it is used in the URL.  You should use something that is not easily guessed.</p>

		<p>The secret word is set in the <b>application/config/routes.php</b> configuration file.</p>

		<div class="example">
			$routing['scaffolding_trigger'] = '';
		</div>

		<p><i>Note</i>: the scaffolding secret word should not start with an underscore.</p>
	</div>

	<div class="content">
		<h1>Enabling Scaffolding</h1>

		<p>This page assumes you already understand how controllers function.  You should have also configured
		CarbonPHP to automatically connect to a database.</p>

		<p>To enable scaffolding you load scaffolding in the controllers constructor.</p>

		<div class="example">
			&lt;?php<br />
			<br />
			class Blog extends Controller<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;public function __construct()<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;parent::__construct();<br />
			<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$this->load->scaffolding('<b>table_name</b>');<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&#125;<br />
			&#125;<br />
			<br />
			?&gt;
		</div>

		<p>Where <b>table_name</b> is the name of the table you wish to work with.  Once you've initialised
		scaffolding you can access it with the following URL.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>class</b>/<b>secret_word</b>/
		</div>

		<p>For example if your controller class was <b>Blog</b> and your secret word was <b>magicword</b>, you would
		use the following URL.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>blog</b>/<b>magicword</b>/
		</div>

		<p>The scaffolding web interface is intuitive and should be easy to understand and navigate. <i>Note:</i>
		scaffolding will only work with tables that have a primary key.  This is because this information is required
		to perform the database tasks.</p>
	</div>
</body>

</html>
